const config = require('../../config');
const assert = require('assert');
const nodemailer = require('nodemailer');
const EMAIL_TEMPLATES = require('./templates')
const props = {
  user: "hello@karishye.co",
  pass: "vliojipzvwfileor"
}

module.exports = class EmailSender {
  constructor(email) {
    this.email = email;
  }
  adminMail = "hello@karishye.co"
  htmlTemplates = EMAIL_TEMPLATES

  replaceAll = (target, pattern, value) => {
    return target.replace(new RegExp(pattern, 'g'), value)
  }

  buildEmailData = (template, emailDynamicData) => {
    let { htmlPart, subject, dynamicKeys } = template
    dynamicKeys.forEach((key) => {
      htmlPart = this.replaceAll(htmlPart, `{{${key}}}`, emailDynamicData[key])
      subject = this.replaceAll(subject, `{{${key}}}`, emailDynamicData[key])
    })
    return {
      htmlBody: htmlPart,
      subject
    }
  }


  async sendEmail({ template, mailProps, dynamicData }) {
    const { htmlBody, subject } = this.buildEmailData(template, dynamicData)

    const transporter = nodemailer.createTransport({
      host: "smtp.gmail.com",
      type: "SMTP",
      port: 587,
      auth: props
    });
    console.log("mailProps.to", mailProps.to)

    return new Promise((resolve, reject) => {
      if (!mailProps.to) {
        resolve("success")
      }
      else if (typeof (mailProps) !== "object") {
        reject(false)
      } else {
        const mailOptions = {
          from: props.user,
          subject: subject,
          html: htmlBody,
          to: mailProps.to || null,
          cc: mailProps.cc || null,
          bcc: mailProps.bcc || null,
          attachments: mailProps.attachments || null
        }

        // send email
        transporter.sendMail(mailOptions, (err, info) => {
          if (err) {
            console.log("Error sending email", err)
          } else {
            resolve("success")
            console.log("Email sent successfully", "=>", mailOptions.to)
          }
        })
      }
    })
  }

  async send() {
    if (!EmailSender.isConfigured) {
      console.error(
        `Email provider is not configured. Please configure it at backend/config/<environment>.json.`,
      );
      return;
    }

    assert(this.email, 'email is required');
    assert(this.email.to, 'email.to is required');
    assert(this.email.subject, 'email.subject is required');
    assert(this.email.html, 'email.html is required');

    const transporter = nodemailer.createTransport(this.transportConfig);

    const mailOptions = {
      from: this.from,
      to: this.email.to,
      subject: this.email.subject,
      html: this.email.html,
    };

    return transporter.sendMail(mailOptions);
  }

  static get isConfigured() {
    return !!config.email && !!config.email.host;
  }

  get transportConfig() {
    return config.email;
  }

  get from() {
    return config.email.from;
  }
};
